/* phcd:  config.c module                                */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.91B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "proto.h"
#include "phcd.h"

int					cfg_changed = 0;
char				cdpath[256];
char				dbpath[256];
char				search_increment;
char				intro_duration;
char				*dbdirs[MAX_DBDIRS];
char				dbdirs_cnt;

static int start_song;

static void cfg_defaults(void)
{
	memset( &cdinfo, 0, sizeof( cdinfo ) );
	cdinfo.fd = -1;
	strcpy( cdpath, CDPATH );
	cdinfo.tmode = T_ELAPSED_TRACK;

	intro_duration = 10;
	search_increment = 5;
}


int cfg_open_device( )
{
	char	buf[255];

	if( cdinfo.fd != -1 ) 
	{
		close( cdinfo.fd );
	}

	if( ( cdinfo.fd = open( cdpath, 0 ) ) == -1 ) 
	{
		fprintf( stderr, "Unable To Open %s", cdpath );
		return( -1 );
	}
	return( 0 );
}

int cfg_init( )
{
	cfg_defaults();
	if( cfg_open_device( ) == -1 ) 
	{
		return -1;
	}
	if( cd_check_discs( ) ) 
	{
		cprintf( "No disk\n" );
	}
	return 0;
	
}

void cfg_dinit( )
{
	cd_stop( );
	cd_clear_discs( );
	close( cdinfo.fd );
	memset( &cdinfo, 0, sizeof( cdinfo ) );
	cdinfo.fd = -1;
}

void cfg_light_display( )
{
	display_NODISC();
}

int
startup()
{

	cfg_defaults( );
	if (start_song) 
	{
		int power = !cfg_init();
		if (power) 
		{
			cdinfo.atrack = start_song;
			cd_play(0);
		}
	}
	return 0;
}


int
parse_opts( int argc, char *argv[] )
{

	/* eliminate 'unreferenced' warnings */
	argc = argc, 
	argv = argv;
    if (argc > 2 && argv[1][0] == 'a')  
		start_song = atoi(argv[2]);
    else 
		start_song = 0;
    
	return 0;

}

